<?xml version="1.0" encoding="UTF-8"?>
<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
    xmlns:xd="http://www.oxygenxml.com/ns/doc/xsl" version="1.0">
    <xd:doc scope="stylesheet">
        <xd:desc>
            <xd:p><xd:b>Created on:</xd:b> Jun 30, 2010</xd:p>
            <xd:p><xd:b>Author:</xd:b> stw</xd:p>
            <xd:p></xd:p>
        </xd:desc>
    </xd:doc>
    
    <xsl:variable name="userids" select="document('exportbuddies.xml')/users/user" />
    

    <xsl:template match="/">
        <html>
            <head>
                <title>
                    Buddy List Report
                </title>
                <style type="text/css">
                    table { width : 100%; border = 1px solid black }
                    th, td { border-bottom : 1px dotted gray; border-right : 1px dotted gray; }
                    .users {font-weight :bold; background-color : #DEDEFF}
                    .grandTotal {font-weight : bold; background-color : #FFDDDD}
                </style>                
            </head>
            <body>
                <table>
                    <thead>
                        <tr><th>User</th><th>Name</th><th>Type</th><th>Total</th></tr>
                    </thead>
                    <tbody>
                        <xsl:apply-templates select="/buddylists/imClientConfig/contactList" />
                        
                        <tr class="grandTotal"><td colspan="3">Grand Total Groups</td>
                            <td>
                                <xsl:value-of select="count(descendant::group)"/> 
                            </td>
                        </tr>
                        <tr><td></td><td colspan="2">public</td>
                            <td>
                                <xsl:value-of select="count(descendant::group[@type='public'])"/> 
                            </td>
                        </tr>
                        <tr><td></td><td colspan="2">private</td>
                            <td>
                                <xsl:value-of select="count(descendant::group[@type='private'])"/> 
                            </td>
                        </tr>
                        <tr class="grandTotal"><td colspan="3">Grand Total Names</td>
                            <td>
                                <xsl:value-of select="count(descendant::user)"/>
                            </td>
                        </tr>
                    </tbody>
                </table>    
                
            </body>
            
        </html>
        
    </xsl:template>
    
    <xsl:template match="contactList">
        
        <tr class="users">
            <td colspan="3">
                <xsl:variable name="curUser" select="../@userid" />
                
                <xsl:value-of select="$userids[@id=$curUser]"/>
                
                <xsl:if test="../communities/community[0]/@email">
                    (<xsl:value-of select="../communities/community[0]/@email"/>)
                </xsl:if>
            </td>
            <td>
                <xsl:value-of select="count(descendant::user)"/> 
            </td>
        </tr>
        
        <xsl:apply-templates select="group" />
        
    </xsl:template>
    
    <xsl:template match="group">
        
        <tr>
            <td></td>
            <td>
                <xsl:value-of select="@name"/>
            </td>
            <td>
                <xsl:value-of select="@type"/>
            </td>
            <td>
                <xsl:value-of select="count(descendant::user)"/>
            </td>
        </tr>
        
    </xsl:template>
    
    
</xsl:stylesheet>
